#include "tdelay.h"
#include "I2CSW.h"

#include <stdio.h>

char e2p_write_byte(unsigned short adr, char data){
	char result;
	i2csw_start();
	result=i2csw_write(0xA0);                   // send eeprom address with LSB set to 0 (writing data address)
	result+=i2csw_write( adr >> 8 );            // send high byte of data address
	result+=i2csw_write( adr & 0x00FF );        // send low byte of data address
	result+=i2csw_write(data);                  // send data to be written to eeprom
	i2csw_stop();
	delay_ms(10);
	return result==4;
}

char e2p_read_byte(unsigned short adr){
	char data;
	i2csw_start();
	i2csw_write(0xA0);                  // send eeprom address with LSB set to 0 (writting data address)
	i2csw_write( adr >> 8 );            // send high byte of data address
	i2csw_write( adr & 0x00FF );        // send low byte of data address
	i2csw_start();
	i2csw_write(0xA1);                  // send eeprom address with LSB set to 1 (reading data)
	data=i2csw_read(NACK);
	i2csw_stop();
	return data;
}


void e2p_read_buf(char *buf,unsigned short adr,char cnut){
	char i;
	if(adr+cnut>256)
		cnut=256-adr;
	i2csw_start();
	i2csw_write(0xA0);                  // send eeprom address with LSB set to 0 (writting data address)
	i2csw_write( adr >> 8 );            // send high byte of data address
	i2csw_write( adr & 0x00FF );        // send low byte of data address
	i2csw_start();
	i2csw_write(0xA1);                  // send eeprom address with LSB set to 1 (reading data)
	for(i=0;i<cnut;i++)
		buf[i]=i2csw_read(ACK);
	i2csw_read(NACK);
	i2csw_stop();
}
