#include "tftlcd.h"
#include <stdio.h>
#include <stdarg.h>
extern int y_text,x_text;

/*
**************************************************************************************************************
*                                         PRINT CHARECTER
*
* Description: This function is used to print a single charecter through UART1.
*
* Arguments  : ch    charecter to be printed
*
* Returns    : None
*
**************************************************************************************************************
*/

void  LCD_PrintChar (char ch)
{

     if (ch == '\n')  {
	if(++y_text>19)	{
		 y_text=0;
		 tftlcd_clear();
		 }
	//y_text++;
	x_text=0;
	return ;
  }
  if(x_text==30){
   	x_text=0;
	if(++y_text>19)	{
		 y_text=0;
		 tftlcd_clear();
		 }
		
  }

  tftlcd_putchar(ch,RED,0,1);
}


/*
**************************************************************************************************************
*                                         PRINT STRING
*
* Description: This function is used to print a string
*
* Arguments  : str    Pointer to the string
*
* Returns    : None
*
**************************************************************************************************************
*/

void  LCD_PrintStr (const char * str)
{

   while ((*str) != 0) {
      if (*str == '\n') {
         LCD_PrintChar(*str++);
      } else {
         LCD_PrintChar(*str++);
      }    
   }
}



/*
**************************************************************************************************************
*                                        PRINT FORMATTED STRING
*
* Description: This function is used to print formatted string. This function takes variable length arguments
*
* Arguments  : variable length arguments
*
* Returns    : None
*
**************************************************************************************************************
*/

void  lprintf (const  char *format, ...)
{
    static  char  buffer[40 + 1];
            va_list     vArgs;


    va_start(vArgs, format);
    vsprintf((char *)buffer, (char const *)format, vArgs);
    va_end(vArgs);
    LCD_PrintStr((char*) buffer);
}

