//---------------------------------------------------------------------------------
//							   Sofware I2c 
//				   Write By Mohammad mazarei @ 1390/6/17
//					Email: mohammad.mazarei@gmail.com
//					 Publish In KavirElectronic.ir
//---------------------------------------------------------------------------------
#include <at91sam7x256.h>
#include <lib_at91sam7x256.h>
#include "I2CSW.h"
#include "tdelay.h"

#define SDA_OUT		AT91F_PIO_CfgOutput(I2cSW_PORT ,(1<<I2cSW_SDA))
#define SDA_IN		AT91F_PIO_CfgInput(I2cSW_PORT ,(1<<I2cSW_SDA))

#define SCL_OUT		AT91F_PIO_CfgOutput(I2cSW_PORT ,(1<<I2cSW_SCL))
#define SCL_IN		AT91F_PIO_CfgInput(I2cSW_PORT ,(1<<I2cSW_SCL))

#define SDA_HI		AT91F_PIO_SetOutput(I2cSW_PORT,1<<I2cSW_SDA)
#define SDA_LO		AT91F_PIO_ClearOutput(I2cSW_PORT,1<<I2cSW_SDA)

#define SCL_HI		AT91F_PIO_SetOutput(I2cSW_PORT,1<<I2cSW_SCL)
#define SCL_LO		AT91F_PIO_ClearOutput(I2cSW_PORT,1<<I2cSW_SCL)

#define I2C_SDA_LOW			SDA_LO;SDA_OUT
#define I2C_SDA_HIGH		SDA_IN;SDA_HI
#define I2C_SCL_LOW			SCL_LO	// Clock Low Output
#define I2C_SCL_HIGH		SCL_HI	// Clock High Output

#define I2CSDELAY		delay_us(1000/I2cSW_CLK)







void i2csw_init(void)
{
	AT91C_BASE_PMC->PMC_PCER = ( 1<<I2cSW_PMC_PORT );
	init_delay();
	SCL_OUT;  									// SCL line defined as output
	I2C_SCL_HIGH;								// Cockleitung auf H setzen
	I2C_SDA_HIGH;								// Datenleitung auf H setzen
	i2csw_stop();
}

void i2csw_clk_toggle(void)
{
	
	I2C_SCL_HIGH;
		I2CSDELAY;
	I2C_SCL_LOW;
 		I2CSDELAY;
}


void i2csw_start(void)
{
	I2C_SDA_HIGH;			// SDA vorsichtshalber auf HIGH ziehen
	I2C_SCL_HIGH;			// SCL auf High
		I2CSDELAY;
	I2C_SDA_LOW;			// SDA auf Low ziehen
		I2CSDELAY;
		I2CSDELAY;
	I2C_SCL_LOW;			// SCL auf low
		I2CSDELAY;
		I2CSDELAY;
}

void i2csw_stop(void)
{
			I2CSDELAY;
	I2C_SDA_LOW;			// SDA vorsichtshalber auf LOW ziehen
			I2CSDELAY;
	I2C_SCL_HIGH;			// SCL auf High setzen
			I2CSDELAY;
	I2C_SDA_HIGH;			// SDA von L auf H ziehen
			I2CSDELAY;
}


unsigned char i2csw_read(unsigned char a)
{	
	unsigned char i,c=0x00;
	
	I2C_SDA_HIGH;

	for(i=0;i<8;i++)
	{
		c=c<<1;
		I2C_SCL_HIGH;
			I2CSDELAY;
		
		// Bitwise OR link to the input, MSB first
		if((AT91F_PIO_GetInput(I2cSW_PORT)&(1<<I2cSW_SDA)))
			c|=1;
		
		I2C_SCL_LOW;
			I2CSDELAY;
	}
	// ACK or NACK | ACK=0; NACK=1
	if(a==ACK)
	{
		I2C_SDA_LOW;
	}
	else
	{
		I2C_SDA_HIGH;
	}
	I2C_SCL_HIGH;
		I2CSDELAY;
	I2C_SCL_LOW;
		I2CSDELAY;
	return c;
}

unsigned char i2csw_write(unsigned char b)
{	
		// END OF WORK SCL =0 , SDA = 1
	char i=0;
	for(i=0;i<8;i++)
	{
		if (b & 0x80)
		{
			I2C_SDA_HIGH;
		}
		else
		{
			I2C_SDA_LOW;
		}
		
		b=b<<1;
			I2CSDELAY;
		i2csw_clk_toggle();
	}
	// Check for ACK from slave
	I2C_SDA_HIGH;
	//i2c_master_clk_toggle();
	I2C_SCL_HIGH;
		I2CSDELAY;
	if((AT91F_PIO_GetInput(I2cSW_PORT)&(1<<I2cSW_SDA))==0)
	{
		I2C_SCL_LOW;
		return 1;
	}
	else
	{ 
		I2C_SCL_LOW;
		return 0;
	}
}

