//---------------------------------------------------------------------------------
//							   Sofware I2c 
//				   Write By Mohammad mazarei @ 1390/6/17
//					Email: mohammad.mazarei@gmail.com
//					 Publish In KavirElectronic.ir
//          slightly modified by: Ali (aref3006 on iranmicro.ir/forum)
//---------------------------------------------------------------------------------


#include <AT91SAM7X256.H>
#include "AT91SAM7X-EK.h"

#include <stdio.h>
#include "debugunit.h"

#include <lib_at91sam7x256.h> 
#include <stdlib.h> //rand() srand()
#include "tdelay.h"
#include "24C64.h"
#include "I2CSW.h"


int main(void) 
{			 
	char rtab[50];
	char rtab1[50];
	char i;
  
	//-------------------------------------------
	// configure debug unit:
	//-------------------------------------------
	/// Default pin configuration (no attribute).
	#define PIO_DEFAULT                 (0 << 0)
	/// The internal pin pull-up is active.
	#define PIO_PULLUP                  (1 << 0)
  // Disable interrupts on the pin(s)
  AT91C_BASE_PIOA->PIO_IDR = 0x18000000;
  // Enable the pull-up(s) if necessary
  if ((PIO_DEFAULT & PIO_PULLUP) ? 1 : 0)
    AT91C_BASE_PIOA->PIO_PPUER = 0x18000000;
  else
    AT91C_BASE_PIOA->PIO_PPUDR = 0x18000000;
  // Configure pin
  AT91C_BASE_PIOA->PIO_ASR = 0x18000000;
  AT91C_BASE_PIOA->PIO_PDR = 0x18000000;
	DBGU_Configure(DBGU_STANDARD, 115200, AT91B_MCK);
	//-------------------------------------------
	
	init_delay();	
	printf("IranMicro EKE V3 Board\n\r");
	printf("I2c Test MEM.\n\r");
	printf("Generate Random Table:\n\r"); 
	printf("Compile time: %s\n\r", __TIME__);
	
	srand(__TIME__[7]*10+__TIME__[8]); // use compile time seconds number as seed
	for(i=0;i<50;i++){
		rtab[i]=rand() % 255;
		printf("%2X ",rtab[i]);
	}
	i2csw_init(); // INStall I2c Bus
	printf("\n\rWrite INTO I2c Mem:\n\r");
	for(i=0;i<50;i++){
		printf("  writing byte #%d: ", i);
		if (!e2p_write_byte(i,rtab[i]))
			printf("error!\n\r");
		else
			printf("OK\n\r");
	}
	printf("OK.\n\r");
	printf("Read From I2c Mem:\n\r");
	e2p_read_buf(rtab1,0,50);
	printf("OK.\n\r");
	for(i=0;i<50;i++){
		printf("%2X ",rtab1[i]);
	}
	printf("\n\rCompare Read & Write Buffer:\n\r");
	for(i=0;i<50;i++){
		if(rtab1[i]!=rtab[i]){
			printf("Error IN Byte %i\n\r",i);
			break; // while(1);
		}
	}
	printf("Compare OK.");
	while(1);
}
